# Use "rpmbuild --without accessdb" to disable per-recipient whitelisting patch

# Where to put the initscript
%{!?_initrddir: %define _initrddir %{_sysconfdir}/rc.d/init.d}

# Name of building user (not defined by default on Mandriva)
%{!?__id_u: %define __id_u /bin/id -u}

Summary:	Milter to enable SPF checking in sendmail
Name:		sendmail-milter-spf
Version:	1.42
Release:	2
License:	GPL
Group:		System Environment/Daemons
URL:		http://srs-socketmap.info/spf/
Source0:	http://srs-socketmap.info/spf/sendmail-milter-spf-%{version}.pl
Source1:	http://srs-socketmap.info/spf/sendmail-milter-INSTALL.txt
Source2:	spf-milter.init
Source3:	spf-milter.sysconfig
Source4:	spf-milter.logrotate
Source5:	HOWTO
Patch0:		sendmail-milter-spf-1.41.patch
Patch1:		sendmail-milter-spf-1.42-directory.patch
Patch2:		sendmail-milter-spf-1.42-accessdb.patch
Requires:	sendmail >= 8.12, logrotate
Requires:	perl(Mail::SPF::Query) >= 1.997, perl(Mail::SRS) >= 0.30
Buildroot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:	noarch
Obsoletes:	spf-milter <= %{name}-%{version}-%{release}
Provides:	spf-milter = %{name}-%{version}-%{release}

Requires(pre):		chkconfig >= 1.3, shadow-utils
Requires(post):		chkconfig >= 1.3
Requires(preun):	chkconfig >= 1.3, /sbin/service
Requires(postun):	/sbin/service

%description
sendmail-milter-spf is a mail filter designed to be used with sendmail
to implement checking of DNS SPF records (see http://spf.pobox.com/)
to detect forged mail sender addresses.

%prep
%setup -c -n sendmail-milter-spf-%{version} -T
%{__cp} %{SOURCE0} sendmail-milter-spf.pl
%{__cp} %{SOURCE1} .
%{__cp} %{SOURCE2} .
%{__cp} %{SOURCE3} .
%{__cp} %{SOURCE4} .
%{__cp} %{SOURCE5} .
%patch0 -p0
%patch1 -p0
%{!?_without_accessdb:%patch2 -p0}
cat << EOF > spf-milter-whitelist
# The whitelist is OPTIONAL. It does not need to exist.
# But if it does, each and every line needs to contain
# a valid entry (IP address, or network address in
# proper CIDR notation).
#
# Valid entries, for example, are:
#
# 127.0.0.1    # my local machine.
# 192.168.64.0/24
# 10.0.0.0/8
# 192.68.1.0-192.68.1.255
# 192.68.0.0/16
127.0.0.0/8
EOF

%build

%install
[ "%{buildroot}" != "/" -a -n "%{buildroot}" ] && %{__rm} -rf %{buildroot}
%{__install} -d -m 755 %{buildroot}%{_initrddir}
%{__install} -d -m 755 %{buildroot}%{_sbindir}
%{__install} -d -m 700 %{buildroot}%{_localstatedir}/run/spf-milter
%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/sysconfig
%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/mail
%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d

%{__install} -m 755 sendmail-milter-spf.pl     %{buildroot}%{_sbindir}/sendmail-milter-spf-%{version}.pl
%{__ln_s} -f sendmail-milter-spf-%{version}.pl %{buildroot}%{_sbindir}/spf-milter
%{__install} -m 755 spf-milter.init            %{buildroot}%{_initrddir}/spf-milter
%{__install} -m 644 spf-milter.sysconfig       %{buildroot}%{_sysconfdir}/sysconfig/spf-milter
%{__install} -m 644 spf-milter.logrotate       %{buildroot}%{_sysconfdir}/logrotate.d/spf-milter
%{__install} -m 644 spf-milter-whitelist       %{buildroot}%{_sysconfdir}/mail/

: > %{buildroot}%{_localstatedir}/run/spf-milter/spf-milter.sock
: > %{buildroot}%{_localstatedir}/run/spf-milter.pid

%clean
[ "%{buildroot}" != "/" -a -n "%{buildroot}" ] && %{__rm} -rf %{buildroot}

%pre
# Create user spf-milt to run the milter
/usr/sbin/useradd -r -d /etc/mail -s /sbin/nologin \
	-c "Milter-SPF" spf-milt &> /dev/null || :
exit 0

%post
/sbin/chkconfig --add spf-milter || :
exit 0

%preun
if [ $1 -eq 0 ]; then
	/sbin/service spf-milter stop &> /dev/null || :
	/sbin/chkconfig --del spf-milter || :
fi
exit 0

%postun
[ $1 -gt 0 ] && /sbin/service spf-milter condrestart &> /dev/null || :
exit 0

%files
%defattr(-,root,root,0755)
%doc HOWTO sendmail-milter-INSTALL.txt
%dir %attr (0700,spf-milt,spf-milt) %{_localstatedir}/run/spf-milter
%{_sbindir}/spf-milter
%{_sbindir}/%{name}-%{version}.pl
%{_initrddir}/spf-milter
%config (noreplace) %{_sysconfdir}/sysconfig/spf-milter
%config (noreplace) %{_sysconfdir}/mail/spf-milter-whitelist
%config (noreplace) %{_sysconfdir}/logrotate.d/spf-milter
%ghost %{_localstatedir}/run/spf-milter/spf-milter.sock
%ghost %{_localstatedir}/run/spf-milter.pid

%changelog
* Tue Aug  9 2005 Paul Howarth <paul@city-fan.org> 1.42-2
- include per-recipient/access.db whitelisting patch

* Mon Aug  8 2005 Paul Howarth <paul@city-fan.org> 1.42-1
- update to 1.42
- update URLs to refer to srs-socketmap.info domain
- use Fedora Extras style BuildRoot and perl dependencies
- ensure directories are owned properly
- tweak patch to be less version-specific
- replace PreReq: tag with Requires(pre) style dependencies
- use versioned obsoletes/provides for spf-milter
- use /etc/mail for home directory of spf-milt user
- use tidier bash syntax in scriptlets
- don't delete account spf-milt on package removal
- restart service on package upgrade
- put pidfile in /var/run instead of /var/spf-milter
- put socket in /var/run/spf-milter instead of /var/spf-milter
- put logs in /var/log instead of /var/spf-milter
- put whitelist in /etc/mail/spf-milter-whitelist
- ghost the socket and pidfile so they get removed properly on package deletion
- add logrotate script

* Tue Apr 27 2004 Paul Howarth <paul@city-fan.org> 1.41-1
- update to 1.41
- perl-Mail-SPF-Query dependency bumped to 1.997 to ensure NXDOMAIN
  handled correctly (particularly for HELO checks)
- add dependency for perl-Net-CIDR needed for whitelist feature

* Wed Apr 14 2004 Paul Howarth <paul@city-fan.org> 1.40-2
- sendmail dependency knocked down to 8.12 (was 8.12.10) in order to
  support stock Red Hat 9

* Sat Mar 27 2004 Paul Howarth <paul@city-fan.org> 1.40-1
- update to 1.40
- add Requires: perl-Mail-SRS >= 0.30
- add note to HOWTO about confMILTER_MACROS_HELO
- patch filename now includes spf-milter version number

* Thu Mar 11 2004 Paul Howarth <paul@city-fan.org> 1.30-4
- initscript fix for /bin/sh compatibility
- patch for better explanation if sendmail.cf does not have
  mail filter spf-milter set up
- both changes suggested by Nico Kadel-Garcia <nkadel@merl.com>

* Mon Feb 09 2004 Paul Howarth <paul@city-fan.org> 1.30-3
- install changed to allow RPM to be built on systems without
  account spf-milt already set up (problem noted by Nico Kadel-Garcia
  <nkadel@merl.com>)

* Fri Jan 30 2004 Paul Howarth <paul@city-fan.org> 1.30-2
- now that spf-milter drops privileges before creating the
  pidfile, the pidfile *has* to go in /var/spf-milter rather
  than /var/run; hence, the patch to move the pidfile into
  /var/run is removed, and the initscript tweaked substantially
  to allow for the non-standard pidfile location

* Fri Jan 30 2004 Paul Howarth <paul@city-fan.org> 1.30-1
- update to 1.30
- changed package name to sendmail-milter-spf (was spf-milter)
- added sendmail-milter-INSTALL.txt document for completeness
  though the HOWTO document should be sufficient for RPM users
- changed initscript and sysconfig file to use -m option instead
  of mx parameter; allows for more versatile option setting
- initscript uses spf-milter -k to stop the milter instead of killproc

* Mon Jan 26 2004 Paul Howarth <paul@city-fan.org> 1.21-1
- update to 1.21
- added /etc/sysconfig/spf-milter to allow parameters to be specified
- run in "mx mode" by default
- require perl-Mail-SPF-Query >= 1.99 (for mx mode and trusted forwarders
  support)
- set BuildArch to noarch

* Fri Jan 23 2004 Paul Howarth <paul@city-fan.org> 1.2-2
- fixed "status" part of initscript

* Thu Jan 22 2004 Paul Howarth <paul@city-fan.org> 1.2-1
- initial RPM build
